﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private serial As Serial
	Private admin As BluetoothAdmin
	Private ast As AsyncStreams
	Public connected As Boolean
	Public connecting As Boolean
End Sub

Sub Service_Create
	serial.Initialize("serial")
	admin.Initialize("admin")
End Sub

Public Sub Connect
	admin.StartDiscovery
	connecting = True
	CallSub(Main, "SetState")
End Sub

Private Sub admin_DeviceFound (Name As String, MacAddress As String)
	If Name = "Makeblock" Then
		Log($"Device found: ${Name}"$)
		Log("Trying to connect...")
		admin.CancelDiscovery
		serial.Connect(MacAddress)
	End If
End Sub

Private Sub admin_DiscoveryFinished
	connecting = False
End Sub

Private Sub Serial_Connected (Success As Boolean)
	If Success Then
		If ast.IsInitialized Then ast.Close
		ast.Initialize(serial.InputStream, serial.OutputStream, "ast")
		Log("Connected")
		connected = True
	Else
		Log(LastException)
	End If
	connecting = False
	CallSub(Main, "SetState")
End Sub

Public Sub SendMessage(msg() As Byte)
	ast.Write(msg)
End Sub

Private Sub ast_NewData (d() As Byte)
	If d.Length=10 Then
		Dim a4 As Int = d(4): If a4<0 Then a4 = 256+a4
		Dim a5 As Int = d(5): If a5<0 Then a5 = 256+a5
		Dim a6 As Int = d(6): If a6<0 Then a6 = 256+a6
		Dim a7 As Int = d(7): If a7<0 Then a7 = 256+a7
		Main.lastResult = a7 + 256*a6 + 256*256*a5 + 256*256*256*a4
	End If
	CallSub(Main, "Command")
	CallSub2(Main, "MessageFromDevice", "Response received")
End Sub

Private Sub ast_Terminated
	connected = False
	CallSub(Main, "SetState")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
